//
// eventView.js
//  To check Eventlog and send (or just display) only recent and needed
//  entries as e-mail. You can specify how recent log you want to receive
//  by command line option.  Filtering rule is defined in IGNORE_LIST entry
//  of this file.
//
//    NOTE: This script is called from eventView.wsf
//
//   Ver 1.0  22 May, 2003  by Hirotada Sasaki
//   Ver 1.1  23 May, 2003  by Hirotada Sasaki
//     Added MANDATORY_LIST function, so that usr can overwrite IGNORE_LIST
//     configuration.
//     Added security configuration for WMI, so that Security log can be read.
//     Changed the way to get Win32_NTLogEvent to use query (WHERE property
//     = value) in order to improve the performance.
//   Ver 1.2  26 May, 2003  by Hirotada Sasaki
//     Changed to remove all empty line(means lines which matchs /^\s*$/).
//   Ver 1.3  05 June, 2003 by Hirotada Sasaki
//     Adapted to use Blatj.exe for sending e-mai.
//       changed -subject to -s, -to to -t, and added white space at the end
//       of the file.(this seems a bug of blatj.exe or tconvlib.dll.)
//     Changed file format from Unix to DOS format.
//

// a data type to keep logfile, source, and type attribute
function IgnoreData(logFile, source, type) {
    this.logFile = logFile;
    this.source = source;
    this.type = type;
}

// main object for this script
// this displays(or sends) only recent and needed log entries.
function EventLog() {
  // properties
  this.limit = utc2cim((new Date()).getTime() - getReportPeriod());
  this.filter = new IgnoreFilter();

  this.oSvc = new ActiveXObject("WbemScripting.SWbemLocator").ConnectServer();
  // below two setting is needed for getting Security Log
  // I think wbemImpersonationLevelImpersonate should be used instead of 3.
  // But system doesn't recognize this.
  //this.oSvc.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate;
  this.oSvc.Security_.ImpersonationLevel = 3;
  this.oSvc.Security_.Privileges.AddAsString("SeSecurityPrivilege");
  this.logs
    = new Enumerator(this.oSvc.ExecQuery
      ("Select * from Win32_NTLogEvent WHERE TimeGenerated > '"
      + this.limit + "'"));
  if ((this.dest = chkDest()) !== "STDOUT") {
    this.WshShell = new ActiveXObject("WScript.Shell");
    this.mail_com = getMailCom(this.dest);
    if (WScript.Arguments.Named.Exists("v")) {
      WScript.Echo("Mail address is specified. The result will be sent via following command.");
      WScript.Echo("\"" + this.mail_com + "\"\n");
    }
    this.oMail = this.WshShell.Exec(this.mail_com);  // run mail command
  } else {
    if (WScript.Arguments.Named.Exists("v")) {
      WScript.Echo("Mail address is not specified. The result will be shown only on screen.\n");
    }
  }

  // methods
  this.show = EventLogShow;
  this.output = EventLogOutput;
  this.close = EventLogClose;
}
  
// check each log entry and if it should be displayed, call EventLogOutput()
function EventLogShow() {
  with (this) {
    for (;!logs.atEnd();logs.moveNext()) {
      if (!(filter.chkIgnore(logs.item().Properties_.Item("Logfile").Value
		, logs.item().Properties_.Item("SourceName").Value
		     , logs.item().Properties_.Item("Type").Value))) {
        with (this.logs.item().Properties_) {
	  this.output(emptyLineDelete(
	    "Log File: " + Item("Logfile").Value + "\n" +
	    "Record Number: " + Item("RecordNumber").Value + "\n" +
	    "Type: " + Item("Type").Value + "\n" +
	    "Time: " + formatTime(Item("TimeGenerated").Value) + "\n" +
	    "Source: " + Item("SourceName").Value + "\n" +
	    "Category: " + Item("Category").Value + "\n" +
	    "Category String: " + Item("CategoryString").Value + "\n" +
	    "Event: " + Item("EventCode").Value + "\n" +
	    "User: " + Item("User").Value + "\n" +
	    "Computer: " + Item("ComputerName").Value + "\n" +
	    "Message: " + Item("Message").Value) + "\n");
	}
      }
    }
  }
}

// remove lines which matcsh /^\s*$/.
function emptyLineDelete(s) {
   var a = s.split("\n");
   var b = "";
   for (var i = 0; i < a.length; i++) {
     if (! a[i].match(/^\s*$/)) {
       b += (a[i] + "\n");
     }
   }
   return(b);
}


// Actual output process (to STDOUT or mail process)
function EventLogOutput(logEntry) {
  if (this.dest === "STDOUT") {
    WScript.Echo(logEntry);
  }
  else {
    this.oMail.StdIn.Write(logEntry + " ");
  }
}

// close stdin of mail, this makes mail process send
function EventLogClose() {
  if (this.dest !== "STDOUT") {
    this.oMail.StdIn.Close();

    if (WScript.Arguments.Named.Exists("v")) {
      WScript.Echo("Output from Blat:");
      while (!this.oMail.StdOut.AtEndOfStream) {	
	var a = this.oMail.StdOut.ReadAll();
	WScript.Echo(a);
      }
      while (!this.oMail.StdErr.AtEndOfStream) {	
	var a = this.oMail.StdErr.ReadAll();
	WScript.Echo(a);
      }
    }
  }
}

// Object which keeps filtering rule
// this provides check method by the filtering rule
function IgnoreFilter() {
  // properties
  this.list = new Array();
  this.mandatory = new Array();

  // methods
  this.chkIgnore = IgnoreFilterchkIgnore;

  // constractor
  if (WScript.Arguments.Named.Exists("v")) {
    WScript.Echo("Filtering rule is");
  }
  pickEntry(this.list, getResource("IGNORE_LIST").split("\n"));

  if (WScript.Arguments.Named.Exists("v")) {
    WScript.Echo("Mandatory rule is");
  }
  pickEntry(this.mandatory, getResource("MANDATORY_LIST").split("\n"));
}

// return 1 if the entry should be ignored
function IgnoreFilterchkIgnore(logFile, source, type) {
  //  if (WScript.Arguments.Named.Exists("v")) {
  //     WScript.Echo("IgnorFilterchkIgnore: logFile=" + logFile
  //	 + ", source=" + source + ", type=" + type);
  //}

  var i;
  with (this) {
    for (i = 0; i < mandatory.length; i++) {
      if (isMatch(logFile, mandatory[i].logFile)
        && isMatch(source, mandatory[i].source)
        && isMatch(type, mandatory[i].type)) {
	return 0;
      }
    }
    for (i = 0; i < list.length; i++) {
      if (isMatch(logFile, list[i].logFile) && isMatch(source, list[i].source)
	&& isMatch(type, list[i].type)) {
	return 1;
      }
    }
    return 0;
  }
}

// return 1 if entry matches ignore
function isMatch(entry, ignore) {
  //if (WScript.Arguments.Named.Exists("v")) {
  //  WScript.Echo("isMatch: entry=" + entry
  //		 + ", ignore=" + ignore);
  //}

  if (ignore.match(/^any$/i)) {
    return 1;
  }
  var pattern = "/^" + entry + "$/i";
  if (ignore.match(eval(pattern))) {
    return 1;
  }
  return 0;
}

// return mail address or stdout
function chkDest() {
  if (WScript.Arguments.Named.Exists("t")) {
    return(WScript.Arguments.Named.Item("t"));
  } else {
    return("STDOUT");
  }
}

// return  a subject for e-mail
function getSubject() {
  if (!WScript.Arguments.Named.Exists("s")) {
    var WshNetwork = WScript.CreateObject("WScript.Network");
    var mail_subject
      = new String(getResource("MAIL_DEFAULT_SUBJECT").match(/\S+/));
    mail_subject = mail_subject.replace(/%SPACE%/g, " ");
    mail_subject = mail_subject.replace(/%SYSTEM%/g, WshNetwork.ComputerName);
    return(mail_subject);
  } else {
    return(WScript.Arguments.Named.Item("s"));
  }
}

// return a from for e-mail
function getFrom() {
  var WshNetwork = WScript.CreateObject("WScript.Network");
  return(WshNetwork.UserDomain + "\\" + WshNetwork.UserName + "@"
      + WshNetwork.ComputerName);
}

// return a mail server to use
function getMailServer() {
  return(getResource("MAIL_SERVER").match(/\S+/));
}

// return a mail sender address
function getMailSender() {
  return(getResource("MAIL_SENDER").match(/\S+/));
}

// return mail command
function getMailCom(mailAddress) {
  var scriptPath =
    WScript.ScriptFullName.substr(0,
      WScript.ScriptFullName.length - WScript.ScriptName.length);
  var mail_com = scriptPath + getResource("MAIL_COMMAND").match(/\S+/);
  mail_com = mail_com.replace(/%SPACE%/g, " ");
  mail_com = mail_com.replace(/%SERVER%/g, "-server " + getMailServer());
  mail_com = mail_com.replace(/%SUBJECT%/g,
    "-s \"" + getSubject() + "\"");
  mail_com = mail_com.replace(/%TO%/g, "-t " + mailAddress);
  mail_com = mail_com.replace(/%FROM%/g, "-i " + getFrom());
  mail_com = mail_com.replace(/%SENDER%/g, "-f " + getMailSender());
  return(mail_com);
}


// return default report period in milisecond
function getDefaultReportPeriod() {
  return(eval(getResource("DEFAULT_REPORT_PERIOD")
	      .match(/\d+/)) * 60 * 60 * 1000);
}

// return report period in milisecond
function getReportPeriod() {
  if (WScript.Arguments.Named.Exists("p")) {
    if (WScript.Arguments.Named.Item("p").match(/(\d+)/)) {
      return(eval(RegExp.$1) * 60 * 60 * 1000);
    }
    else {
      WScript.Echo("Warning! /p option seems wrong, use default value.");
    }
  } else {
    return(getDefaultReportPeriod());
  }
}

// to pick up entry from array a, and push it to list
function pickEntry(list, a) {
  for (var i = 0; i < a.length; i++) {
    a[i] = a[i].replace(/^([^#]*)#.*$/, "$1");
    if (a[i].match(/"(.*)"\s+"(.*)"\s+"(.*)"/)) {
      list.push(new IgnoreData(RegExp.$1, RegExp.$2, RegExp.$3));
      if (WScript.Arguments.Named.Exists("v")) {
        WScript.Echo("LogFile=\"" + RegExp.$1 + "\", Source=\"" + RegExp.$2
		     + "\", Type=\"" + RegExp.$3 + "\"");
      }
    }
  }
  if (WScript.Arguments.Named.Exists("v")) {
    WScript.Echo();
  }
}

// convert UTC to cim, return cim format string
function utc2cim(utc) {
  var utcDate = new Date(utc);
  var cimDate = utcDate.getUTCFullYear().toString();
  cimDate += int2twoDig(utcDate.getUTCMonth() + 1);
  cimDate += int2twoDig(utcDate.getUTCDate());
  cimDate += int2twoDig(utcDate.getUTCHours());
  cimDate += int2twoDig(utcDate.getUTCMinutes());
  cimDate += int2twoDig(utcDate.getUTCSeconds());
  cimDate += ".000000+000";
  return(cimDate);
}

//
function int2twoDig(n)
{
  if (n < 10) {
    return ("0" + n.toString(10));
  } else {
    return (n.toString(10));
  }
}

// To convert cim format string to easy readable format(yyyy-mm-dd hh:MM:ss)
function formatTime(cimDate) {
  var sec = cimDate.substr(12, 2);
  var min = cimDate.substr(10, 2);
  var hour = cimDate.substr(8, 2);
  var day = cimDate.substr(6, 2);
  var mon = cimDate.substr(4, 2);
  var year = cimDate.substr(0, 4);
  return(year + "-" + mon + "-" + day + " " + hour + ":" + min + ":" + sec);
}


// end of this file
